C $Header: /u/gcmpack/MITgcm_contrib/darwin2/pkg/darwin/darwin_fe_chem.F,v 1.1 2011/04/13 18:56:24 jahn Exp $
C $Name:  $

c#include "DIC_OPTIONS.h"
#include "DARWIN_OPTIONS.h"

CStartOfInterFace
      SUBROUTINE DARWIN_Fe_CHEM(
     I           bi,bj,iMin,iMax,jMin,jMax,
     U           fe,
     O           freefe,
     I           myIter, myThid )
C     /==========================================================\
C     | SUBROUTINE Fe_chem                                       |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DARWIN_PARAMS.h"
#include "MONOD_SIZE.h"
#include "MONOD.h"

C     == Routine arguments ==                
C     bi, bj, iMin, iMax, jMin, jMax - Range of points for which calculation
C                                      results will be set.
C     myThid - Instance number for this innvocation of CALC_GT
      _RL  freefe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  fe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER myIter,myThid
CEndOfInterface
      INTEGER I,J,K
      _RL  tmpFeL, tmpfefree, tmpf, tmpdf, tmpL1, tmpL2
      _RL  tmpL3, tmpL4 
      _RL  tmpfefreea, tmperror
      INTEGER inewton, inewtonmax
      _RL  tmpfe

CAPHAM set the number of iteration
      inewtonmax = 20

C ligand balance in surface layer
C in surface layer

       DO j=jmin,jmax
        DO i=imin,imax
         DO k=1,nR
          IF(hFacC(i,j,k,bi,bj) .gt. 0.0 _d 0)THEN

C start with non zero Fe
              tmpfe=max(0. _d 0 , fe (i,j,k))
CAPHAM Include L1 and L2 
              tmpL1=ligand(i,j,k,bi,bj,1)
              tmpL2=ligand(i,j,k,bi,bj,2)
              tmpL3=ligand(i,j,k,bi,bj,3)
              tmpL4=ligand(i,j,k,bi,bj,4)

C initialize and prepare for the iterative loop
              tmpfefree = 0.
              tmpf = -tmpfe + tmpfefree*(
     &    1.0 +ligand_stab(1)*tmpL1/(ligand_stab(1)*tmpfefree+1.0)
     &        +ligand_stab(2)*tmpL2/(ligand_stab(2)*tmpfefree+1.0)
     &        +ligand_stab(3)*tmpL3/(ligand_stab(3)*tmpfefree+1.0)
     &        +ligand_stab(4)*tmpL4/(ligand_stab(4)*tmpfefree+1.0))

            tmpdf = 1.0
     &     +ligand_stab(1)*tmpL1/(ligand_stab(1)*tmpfefree+1.0)
     &     +ligand_stab(2)*tmpL2/(ligand_stab(2)*tmpfefree+1.0)
     &     +ligand_stab(3)*tmpL3/(ligand_stab(3)*tmpfefree+1.0)
     &     +ligand_stab(4)*tmpL4/(ligand_stab(4)*tmpfefree+1.0)
     &     -tmpfefree*(
     &     (ligand_stab(1)**2)*tmpL1/((ligand_stab(1)*tmpfefree+1.0)**2)
     &     +(ligand_stab(2)**2)*
     &       tmpL2/((ligand_stab(2)*tmpfefree+1.0)**2)
     &     +(ligand_stab(3)**2)*
     &       tmpL3/((ligand_stab(3)*tmpfefree+1.0)**2)
     &     +(ligand_stab(4)**2)*
     &       tmpL4/((ligand_stab(4)*tmpfefree+1.0)**2))

              tmpfefreea = tmpfefree - tmpf/tmpdf
              tmperror = tmpfefreea - tmpfefree
C start the iterative loop
              DO inewton = 1, inewtonmax
              
              tmpfefree = tmpfefreea
              tmpf = -tmpfe + tmpfefree*(
     &    1.0 +ligand_stab(1)*tmpL1/(ligand_stab(1)*tmpfefree+1.0)
     &        +ligand_stab(2)*tmpL2/(ligand_stab(2)*tmpfefree+1.0)
     &        +ligand_stab(3)*tmpL3/(ligand_stab(3)*tmpfefree+1.0)
     &        +ligand_stab(4)*tmpL4/(ligand_stab(4)*tmpfefree+1.0))
            tmpdf = 1.0
     &     +ligand_stab(1)*tmpL1/(ligand_stab(1)*tmpfefree+1.0)
     &     +ligand_stab(2)*tmpL2/(ligand_stab(2)*tmpfefree+1.0)
     &     +ligand_stab(3)*tmpL3/(ligand_stab(3)*tmpfefree+1.0)
     &     +ligand_stab(4)*tmpL4/(ligand_stab(4)*tmpfefree+1.0)
     &     -tmpfefree*(
     &     (ligand_stab(1)**2)*tmpL1/((ligand_stab(1)*tmpfefree+1.0)**2)
     &     +(ligand_stab(2)**2)*
     &       tmpL2/((ligand_stab(2)*tmpfefree+1.0)**2)
     &     +(ligand_stab(3)**2)*
     &       tmpL3/((ligand_stab(3)*tmpfefree+1.0)**2)
     &     +(ligand_stab(4)**2)*
     &       tmpL4/((ligand_stab(4)*tmpfefree+1.0)**2))
              
              tmpfefreea = tmpfefree - tmpf/tmpdf
              tmperror = tmpfefreea - tmpfefree
              
              ENDDO
C post-process after the iteration
              freefe(i,j,k) = tmpfefreea
              FeL(i,j,k,bi,bj,1)=
     &        +ligand_stab(1)*tmpfefreea*tmpL1
     &         /(ligand_stab(1)*tmpfefreea+1.0)
              FeL(i,j,k,bi,bj,2)=
     &        +ligand_stab(2)*tmpfefreea*tmpL2
     &         /(ligand_stab(2)*tmpfefreea+1.0)
              FeL(i,j,k,bi,bj,3)=
     &        +ligand_stab(3)*tmpfefreea*tmpL3
     &         /(ligand_stab(3)*tmpfefreea+1.0)
              FeL(i,j,k,bi,bj,4)=
     &        +ligand_stab(4)*tmpfefreea*tmpL4
     &         /(ligand_stab(4)*tmpfefreea+1.0)
              tmpFeL = FeL(i,j,k,bi,bj,1) + FeL(i,j,k,bi,bj,2)
     &                 + FeL(i,j,k,bi,bj,3)+ FeL(i,j,k,bi,bj,4)
              freefe(i,j,k) = min(freefe(i,j,k),freefemax)
              fe(i,j,k) = tmpFeL+freefe(i,j,k)

          END IF  
         ENDDO
        ENDDO
       ENDDO    
c
        RETURN
        END                      
